<template>
  <section>
    <div class="text-center mb-3">
      <b-form-select v-model="filter" :options="options"></b-form-select>
    </div>

    <div v-if="!err" class="image-list">
      <div
        v-for="(breed, index) in filteredBreeds"
        :key="`${breed.breed}-${index}`"
        @click="toggleModalSubBreed({ isOpen: true, breed: breed.breed })"
      >
        <ImageGrid :source="breed" class="cursor-pointer" />
      </div>
    </div>

    <b-alert v-else :show="!!err" variant="danger">
      {{ err }}
    </b-alert>

    <ImageModal
      v-bind="modalSubBreed"
      @close="toggleModalSubBreed({ isOpen: false })"
    />
  </section>
</template>

<script setup>
import { computed, onBeforeUnmount, onMounted, ref } from 'vue'
import { useStore } from '@nuxtjs/composition-api'

const store = useStore()

const dogBreeds = computed(() =>
  Object.keys(store.state.dog?.dog_breeds).map((key) => ({
    breed: key,
    breeds: store.state.dog?.dog_breeds[key],
    subtitle: `${store.state.dog?.dog_breeds[key]?.length || 0} Breeds`,
  }))
)

const filter = ref(null)
const options = ref([
  { value: null, text: 'All Breeds' },
  { value: { min: 1, max: 5 }, text: '1 - 5 Breeds' },
  { value: { min: 6, max: 10 }, text: '6 - 10 Breeds' },
  { value: { min: 11 }, text: '> 10 Breeds' },
])
const err = ref(null)

const filteredBreeds = computed(() => {
  if (!filter.value) return dogBreeds.value

  return dogBreeds.value.filter((val) => {
    const min = !filter.value.min || val.breeds.length >= filter.value.min
    const max = !filter.value.max || val.breeds.length <= filter.value.max
    return min && max
  })
})

const fetchList = async () => {
  try {
    await store.dispatch('dog/dog_fetchBreedList')
  } catch (error) {
    err.value = error
  }
}

onMounted(() => {
  fetchList()
})

onBeforeUnmount(() => {
  store.commit('dog/dog_SET_BREEDS', {})
})

const modalSubBreed = ref({
  isOpen: false,
  breed: '',
})

const toggleModalSubBreed = (options = {}) => {
  modalSubBreed.value = {
    isOpen: options.isOpen || false,
    breed: options.breed || '',
  }
}
</script>
